<template>
    <div>
        <b-tabs v-model="activeTab">
            <b-tab-item label="Add Element">

                <ul>
                    <li>
                        <a @click.prevent="addField('text')">Text Field</a>
                    </li>
                    <li>
                        <a @click.prevent="addField('checkbox')">Checkbox</a>
                    </li>
                </ul>

            </b-tab-item>

            <b-tab-item label="Element properties" :disabled="currentItem === null">
                <div v-if="editing" :is="editor"></div>
            </b-tab-item>

        </b-tabs>
    </div>
</template>
<script>
    import {mapActions, mapGetters} from 'vuex'
    import CheckboxFieldEditor from './editors/CheckboxFieldEditor.vue'
    import TextFieldEditor from './editors/TextFieldEditor.vue'

    export default {
        components: {'CheckboxFieldEditor': CheckboxFieldEditor, 'TextFieldEditor': TextFieldEditor},
        data() {
            return {
                activeTab: 0,
                showBooks: true
            }
        },
        computed: {
            ...mapGetters(['currentItem', 'allItems']),
            editor() {
                if (this.currentItem !== null) {
                    return `${this.allItems[this.currentItem].el}Editor`
                }
            },
            editing() {
                try {
                    return this.allItems[this.currentItem];
                } catch (e) {
                    return null;
                }
            }
        },
        watch: {
            currentItem(newValue, oldValue) {
                if (newValue === null) {
                    this.activeTab = 0
                } else {
                    this.activeTab = 1
                }
            }
        },
        methods: {
            ...mapActions(['addItem']),
            addField(type) {
                switch (type) {
                    case 'text':
                        this.addItem({el: 'TextField', type: 'text', placeholder: 'Musaka', label: 'Hello Musaka'});
                        break;
                    case 'checkbox':
                        this.addItem({el: 'CheckboxField', label: 'Basic 2'});
                        break;
                }
            }
        }
    }
</script>